;**************************************************************************
;
;                           PVK40 Example : Blink
;
; Processor : PIC18F4520
; Clock : XT 3.2768 MHz
;
; On your PVK40 board set DIP switches according to following way:
; 1) Switch off all DIP switches except:
; 2) Switch on OSC 3.276M on S9
; 3) Switch on B3 LED on S11
;**************************************************************************
; Assembler directives :
        list    p = PIC18F4520  ; processor type
        __config 0x300001,0x01  ; configuration settings
        __config 0x300002,0x06
        __config 0x300003,0x00
        __config 0x300005,0x85
        __config 0x300006,0x80
        __config 0x300008,0x0F
        __config 0x300009,0xC0
        __config 0x30000A,0x0F
        __config 0x30000B,0xE0
        __config 0x30000C,0x0F
        __config 0x30000D,0x40
;--------------------------------------------------------------------------
; Special Function Register definition :
portb   equ     0xF81
trisb   equ     0xF93
; General Purpose Register definition :
cnt1    equ     0x00            ;used for Wait subroutine
cnt2    equ     0x01            ;used for Wait subroutine
cnt3    equ     0x02            ;used for Wait subroutine
; Destination definition :
w       equ     0x00
f       equ     0x01
; RAM access bit definition :
a       equ     0x00            ;access RAM
banked  equ     0x01            ;bank specified by BSR register
; Bits definition :
#define LED     portb,3         ;LED is on the RB3 pin
;--------------------------------------------------------------------------
        org     0               ;program starts at address 0x000
        movlw   B'11110111'
        movwf   trisb,a         ;pin RB3 is output
;
Main:   bsf     LED,a           ;LED on
        call    Wait            ;wait 0.5 second
        bcf     LED,a           ;LED off
        call    Wait            ;wait 0.5 second
        goto    Main            ;closes the loop
;--------------------------------------------------------------------------
Wait:   movlw   0x05            ;this subroutine wait 0.5 second
        movwf   cnt3,a          ;1 cycle = 1/(Fosc/4) second =>
Wait_A: movlw   0x6B            ;=> we need 409600 cycles
        movwf   cnt2,a          ;0x05*0x6B*0xFF*3 = 409275
Wait_B: movlw   0xFF
        movwf   cnt1,a
Wait_C: decfsz  cnt1,f,a        ;decrement cnt1
        goto    Wait_C
        decfsz  cnt2,f,a        ;and if cnt1=0 then decrement cnt2
        goto    Wait_B
        decfsz  cnt3,f,a        ;and if cnt2=0 then decrement cnt3
        goto    Wait_A
        return                  ;if cnt3=0 then return
;**************************************************************************
; end of PVK40 Example : Blink
        end
