;**************************************************************************
;
;          PVK40 Example : Infra-red Reflective photoelectric sensor
;
; Processor : PIC16F877A
; Clock : XT 3.2768 MHz
;
; On your PVK40 board set DIP switches according to following way:
; 1) Switch off all DIP switches except:
; 2) Switch on OSC 3.276M on S9
; 3) Switch on B3 LED on S11
; 4) Switch on B5 IRF_TX on S11
; 5) Switch on C0 IRF_RX on S11
;**************************************************************************
; Assembler directives :
        list    p = PIC16F877A  ; processor type
        __config 0x3F71         ; configuration setting
;--------------------------------------------------------------------------
; Special Function Register definition :
        #include <P16f877a.INC>
; General Purpose Register definition :
cnt1    equ     0x20            ;used in Wait subroutine
; Bits definition :
#define IRFRX   portc,0         ;IR input
#define IRFTX   portb,5         ;IR output
#define LED     portb,3         ;LED
;--------------------------------------------------------------------------
        org     0               ;program starts at address 0x000
Start:  bsf     status,RP0      ;bank 1
        movlw   B'11010111'     ;pins RB3,5 are outputs
        movwf   trisb
        bcf     status,RP0      ;bank 0
;
Main:   btfsc   IRFRX           ;test input
        bsf     LED             ;turn on the LED
        btfss   IRFRX
        bcf     LED             ;turn off the LED
        bsf     IRFTX           ;turn on IR LED
        nop
        nop
        bcf     IRFTX           ;turn off IR LED
        call    Wait            ;wait 14 us -> period = 26.5 us
        goto    Main            ;closes the loop
;--------------------------------------------------------------------------
; Subroutines :
Wait:   movlw   0x02            ;this subroutine wait 12 cycles
        movwf   cnt1
Wait_B: decfsz  cnt1,f          ;decrement cnt1
        goto    Wait_B
        nop                     ;if cnt1=0 then return
        return
;**************************************************************************
; end of PVK40 Example : Infra-red Reflective photoelectric sensor
        end
