;**************************************************************************
;
;          PVK40 Example : Infra-red Reflective photoelectric sensor
;
; Processor : PIC18F4520
; Clock : XT 3.2768 MHz
;
; On your PVK40 board set DIP switches according to following way:
; 1) Switch off all DIP switches except:
; 2) Switch on OSC 3.276M on S9
; 3) Switch on B3 LED on S11
; 4) Switch on B5 IRF_TX on S11
; 5) Switch on C0 IRF_RX on S11
;**************************************************************************
; Assembler directives :
        list    p = PIC18F4520  ; processor type
        __config 0x300001,0x01  ; configuration settings
        __config 0x300002,0x06
        __config 0x300003,0x00
        __config 0x300005,0x85
        __config 0x300006,0x80
        __config 0x300008,0x0F
        __config 0x300009,0xC0
        __config 0x30000A,0x0F
        __config 0x30000B,0xE0
        __config 0x30000C,0x0F
        __config 0x30000D,0x40
;--------------------------------------------------------------------------
; Special Function Register definition :
        #include <P18f4520.INC>
; General Purpose Register definition :
cnt1    equ     0x00            ;used in Wait subroutine
; Bits definition :
#define IRFRX   portc,0         ;IR input
#define IRFTX   portb,5         ;IR output
#define LED     portb,3         ;LED
;--------------------------------------------------------------------------
        org     0               ;program starts at address 0x000
Start:  movlw   B'11010111'     ;pins RB3,5 are outputs
        movwf   trisb,a
;
Main:   btfsc   IRFRX,a         ;test input
        bsf     LED,a           ;turn on the LED
        btfss   IRFRX,a
        bcf     LED,a           ;turn off the LED
        bsf     IRFTX,a         ;turn on IR LED
        nop
;       nop                     ;optional -> increase output power
        bcf     IRFTX,a         ;turn off IR LED
        call    Wait            ;wait 14 us => period = 26.5 us
        goto    Main            ;closes the loop
;--------------------------------------------------------------------------
; Subroutines :
Wait:   movlw   0x02            ;this subroutine wait 12 cycles
        movwf   cnt1,a
Wait_B: decfsz  cnt1,f,a        ;decrement cnt1
        goto    Wait_B
        nop                     ;if cnt1=0 then return
        return
;**************************************************************************
; end of PVK40 Example : Infra-red Reflective photoelectric sensor
        end
