;**************************************************************************
;
;                         PVK40 Example : UART - Tx
;
; Processor : PIC18F4520
; Clock : 13.1072 MHz, crystal 3.2768 MHz with x4 PLL used
;
; Serial port : 115200 Bd,8 db,parity none,1 stop bit,flow control none
;
; On your PVK40 board :
; 1) Switch off all DIP switches except:
; 2) Switch on OSC 3.276M on S9
; 3) Switch on C6 UART_TX on S11
; 4) If USB selected, insert UMS1 module into socket
;**************************************************************************
; Assembler directives :
        list    p = PIC18F4520  ; processor type
        __config 0x300001,0x06  ; configuration settings
        __config 0x300002,0x06
        __config 0x300003,0x00
        __config 0x300005,0x85
        __config 0x300006,0x80
        __config 0x300008,0x0F
        __config 0x300009,0xC0
        __config 0x30000A,0x0F
        __config 0x30000B,0xE0
        __config 0x30000C,0x0F
        __config 0x30000D,0x40
;--------------------------------------------------------------------------
; Special Function Register definition :
        #include <P18f4520.INC>
; General Purpose Register definition :
pointer equ     0x00            ;points to characters in Table
latchw  equ     0x01            ;save Wreg
;--------------------------------------------------------------------------
        org     0               ;program starts at address 0x000
Start:  movlw   B'10000000'     ;serial port enabled, pin RC6 is
        movwf   rcsta,a         ; automaticaly configured as output
        movlw   B'00100100'     ;enable transmit
        movwf   txsta,a
        movlw   B'01000000'
        movwf   baudcon,a
        movlw   0x06            ;115200 Bd
        movwf   spbrg,a
        clrf    pointer,a
Main:   call    Table
        movwf   latchw,a        ;make advance
        movf    latchw,f,a
        btfsc   status,Z,a      ;repeat procedure until latchw = 0x00
        goto    Loop            ;last character in table was found
        movf    latchw,w,a
        call    Send            ;send character from table
        incf    pointer,f,a     ;take next character
        goto    Main
;
Loop:   goto    Loop            ;never-ending loop
;--------------------------------------------------------------------------
; Subroutines :
Send:   movwf   txreg,a         ;send data
Send2:  btfss   txsta,TRMT,a
        goto    Send2
        return
;
Table:  rlncf   pointer,w,a     ;table of legend
        andlw   B'00011110'     ;overflow prevention
        addwf   pcl,f,a         ;wreg * 2 -> pcl
        retlw   'H'
        retlw   'e'
        retlw   'l'
        retlw   'l'
        retlw   'o'
        retlw   ','
        retlw   ' '
        retlw   'W'
        retlw   'o'
        retlw   'r'
        retlw   'l'
        retlw   'd'
        retlw   '!'
        retlw   0x0D            ;new line
        retlw   0x0A
        retlw   0x00
        retlw   0x00            ;prohibited zone
        retlw   0x00            ;prohibited zone
;**************************************************************************
; end of PVK40 Example : UART - Tx
        end
