;**************************************************************************
;
;                           PVK40 Example : Piano
;
; Processor : PIC18F4520
; Clock : XT 3.2768 MHz
;
; On your PVK40 board set DIP switches according to following way:
; 1) Switch off all DIP switches except:
; 2) Switch on OSC 3.276M on S9
; 3) Switch on C2 BUZZER on S11
;**************************************************************************
; Assembler directives :
        list    p = PIC18F4520  ; processor type
        __config 0x300001,0x01  ; configuration settings
        __config 0x300002,0x06
        __config 0x300003,0x00
        __config 0x300005,0x85
        __config 0x300006,0x80
        __config 0x300008,0x0F
        __config 0x300009,0xC0
        __config 0x30000A,0x0F
        __config 0x30000B,0xE0
        __config 0x30000C,0x0F
        __config 0x30000D,0x40
;--------------------------------------------------------------------------
; Special Function Register definition :
        #include <P18f4520.INC>
; Bits definition :
#define PB0     portd,0         ;pushbutton 0
#define PB1     portd,1         ;pushbutton 1
#define PB2     portd,2         ;pushbutton 2
#define PB3     portd,3         ;pushbutton 3
#define PB4     portd,4         ;pushbutton 4
#define PB5     portd,5         ;pushbutton 5
#define PB6     portd,6         ;pushbutton 6
#define PB7     portd,7         ;pushbutton 7
;--------------------------------------------------------------------------
        org     0               ;program starts at address 0x000
Start:  clrf    ccpr1h,a        ;PWM duty cycle = 0%
        clrf    ccpr1l,a
        movlw   B'00001100'     ;CCP1 mode = PWM
        movwf   ccp1con,a
        clrf    tmr2,a
        movlw   B'00000111'     ;timer2 on, prescaler 1:16
        movwf   t2con,a
        movlw   B'11111011'     ;pin RC2 is output
        movwf   trisc,a
;
Main:   btfss   PB0,a           ;test pushbutton 0
        bra     T_c2
        btfss   PB1,a           ;test pushbutton 1
        bra     T_d2
        btfss   PB2,a           ;test pushbutton 2
        bra     T_e2
        btfss   PB3,a           ;test pushbutton 3
        bra     T_f2
        btfss   PB4,a           ;test pushbutton 4
        bra     T_g2
        btfss   PB5,a           ;test pushbutton 5
        bra     T_a2
        btfss   PB6,a           ;test pushbutton 6
        bra     T_h2
        btfss   PB7,a           ;test pushbutton 7
        bra     T_c3
        clrf    ccpr1l,a        ;none pushbutton is pressed
        goto    Main            ;closes the loop
;
T_c2:   movlw   0x61            ;setup PWM frequency
        movwf   pr2,a
        movlw   0x05            ;PWM duty cycle
        movwf   ccpr1l,a
        goto    Main            ;closes the loop
;
T_d2:   movlw   0x56            ;setup PWM frequency
        movwf   pr2,a
        movlw   0x04            ;PWM duty cycle
        movwf   ccpr1l,a
        goto    Main            ;closes the loop
;
T_e2:   movlw   0x4D            ;setup PWM frequency
        movwf   pr2,a
        movlw   0x04            ;PWM duty cycle
        movwf   ccpr1l,a
        goto    Main            ;closes the loop
;
T_f2:   movlw   0x48            ;setup PWM frequency
        movwf   pr2,a
        movlw   0x04            ;PWM duty cycle
        movwf   ccpr1l,a
        goto    Main            ;closes the loop
;
T_g2:   movlw   0x40            ;setup PWM frequency
        movwf   pr2,a
        movlw   0x03            ;PWM duty cycle
        movwf   ccpr1l,a
        goto    Main            ;closes the loop
;
T_a2:   movlw   0x39            ;setup PWM frequency
        movwf   pr2,a
        movlw   0x03            ;PWM duty cycle
        movwf   ccpr1l,a
        goto    Main            ;closes the loop
;
T_h2:   movlw   0x33            ;setup PWM frequency
        movwf   pr2,a
        movlw   0x03            ;PWM duty cycle
        movwf   ccpr1l,a
        goto    Main            ;closes the loop
;
T_c3:   movlw   0x30            ;setup PWM frequency
        movwf   pr2,a
        movlw   0x02            ;PWM duty cycle
        movwf   ccpr1l,a
        goto    Main            ;closes the loop
;**************************************************************************
; end of PVK40 Example : Piano
        end
