/*============================================================================

                        PVK40 Example : Wire

 Compiler/IDE : PICC-Lite and MPLAB

 Processor : PIC16F877A
 Clock : XT 3.2768 MHz

 On your PVK40 board set DIP switches according to following way:
 1) Switch off all DIP switches except:
 2) Switch on OSC 3.276M on S9
 3) Switch on B3 LED on S11

============================================================================*/


/*============================================================================

       INCLUDE

============================================================================*/
#include <pic.h>


/*============================================================================

       Configuration Bits

============================================================================*/
__CONFIG(UNPROTECT & DEBUGDIS & WRTEN & DUNPROT & LVPDIS 
   & BOREN & PWRTEN & WDTDIS & XT); 


/*============================================================================

       User definition

============================================================================*/
#define PORTBIT(adr,bit) ((unsigned)(&adr)*8+(bit)) //no modify this line

static bit button @ PORTBIT(PORTD,0);
static bit led @ PORTBIT(PORTB,3);


/*============================================================================

       Program

============================================================================*/

int main(void)
{

  TRISB=0xF7;
  TRISD=0xFF;

  for(;;) {
    if (button==0)
      led=1;
    else
      led=0;
  }

}
