/*============================================================================

                        PVK40 Example : LCD - Hello,World!

 Compiler/IDE : PICC-Lite and MPLAB

 Processor : PIC16F877A
 Clock : XT 3.2768 MHz

 On your PVK40 board set DIP switches according to following way:
 1) Insert MC1602 LCD module into LCD_DISPLAY_CONNECTOR
 2) Switch off all DIP switches except:
 3) Switch on OSC 3.276M on S9

============================================================================*/


/*============================================================================

       INCLUDE

============================================================================*/
#include <pic.h>
#include "lcd.h"

/*============================================================================

       Configuration Bits

============================================================================*/
__CONFIG(UNPROTECT & DEBUGDIS & WRTEN & DUNPROT & LVPDIS 
   & BOREN & PWRTEN & WDTDIS & XT); 


/*============================================================================

       User definition

============================================================================*/

#define PORTBIT(adr,bit) ((unsigned)(&adr)*8+(bit)) //don't modify this line

/*============================================================================

       Program

============================================================================*/

void lcd_puts(const char *s)
{
  while(*s) {        
    DispWrByte(*(s++),1,50);
  }
}

int main(void)
{
  DispHwInit();

  lcd_puts(" Hello, World!");

  for(;;);
}
